	include "tios.h"
	include "filelib.h"
 include "graphlib.h"
 include "hufflib.h"
;	include "userlib.h"
 xdef _main
 xdef _comment
 xdef _ti89


_comment:
   dc.b "Zelda 89 Version .10b",0

 include "macros.asm"
 include "scroll&pause.asm"
 include "bgs.asm"
 include "mct.asm"
 include "timing.asm"
 include "links.asm"
 include "dialog.asm"
	include "badgpos.asm"

_main:
 bsr saveint
 jsr graphlib::gray4
restart:
 bsr clearprogs
 bsr clrbadgbg
 bsr clearenmy
 move.w #1,olddir
 move.w #1,oddeven
 move.w #0,swordtiming
 move.w #0,lastkey
 move.w #0,pushtrig

 move.l #compressedbg,a0
 move.l #bgmx,a1
 move.w #0,d3
 jsr hufflib::extract

 move.l #titlePicBits,a0
 move.l #screensave0,a1
 move.w #0,d3
 jsr hufflib::extract
 bsr restoreScreen
 bsr pausethegame
	bsr fadeup
	clr.l	d0
	move.l #screensave0,a0
	move.l #screensave1,a1
	moveq	#99,d0

\clr1:
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a1)+
	clr.l	(a1)+
	clr.l	(a1)+
	clr.l	(a1)+
	clr.l	(a1)+
	dbra	d0,\clr1
 bsr mctwist
 bsr calcpos
 lea curbg(pc),a6
 bsr bgdisplay
 bsr fadedown
 move.w #0,invincible
 bsr ifenmy
redraw:

 lea curbg(pc),a1
 bsr rebgdisp

controlLoop:

 bsr timing

 move.w #$3500,d3
 bsr wait

 bsr timing2

 move.w #%111111110,d0
 bsr ReadKBD

 btst.b #4,d0
 beq second
 move.w #0,lastkey
secondback:


 cmp.w #0,swordtiming
 bne holdingsword
holdingback:


 move.w #%111101111,d0
 bsr ReadKBD

 btst.b #7,d0
 beq dispslct

 move.w #%110111111,d0
 bsr ReadKBD

 btst.b #0,d0
 beq enter

 move.w oddeven,optch
 move.w #%111111110,d0
 bsr ReadKBD
 move.w d0,d4

 btst.b #0,d4
 beq up
upback:

 btst.b #2,d4
 beq down
downback:

 btst.b #3,d4
 beq right
rightback:

 btst.b #1,d4
 beq left
leftback:
 move.w direction,olddir
 move.w oddeven,d0
 cmp.w optch,d0
 beq setoddevento1
 bra controlLoop

setoddevento1:
 move.w #1,oddeven
 bra controlLoop

holdingsword:
 cmp.w #4,swordtiming
 bgt controlLoop
 move.w counter,d0
 btst.w #0,d0
 bne controlLoop
 bra holdingback

detect:
 move.w ySprite,d1
 move.w xSprite,d0
 clr.l d5
 bsr dtct
 btst #6,d5
 bne gohouse
detectback:
 move.w d5,d0
 rts

right:
 move.w oddeven,d0
 rol.w #1,d0
 move.w d0,oddeven

 move.w #0,direction
 cmp.w #146,xSprite
 beq rightscroll
 add.w #12,xSprite	;x+16 (test on right side)

 add.w #6,ySprite
 bsr detect
 sub.w #6,ySprite

 btst #7,d0
 bne unright

 add.w #14,ySprite
 bsr detect
 sub.w #14,ySprite

 btst #7,d0
 bne unright

 sub.w #10,xSprite	;ok => 16-14=+2

 bra rightback

unright:
 sub.w #12,xSprite	;not ok => 16-16=0
 bsr push
 bra rightback


left:
 move.w oddeven,d0
 rol.w #1,d0
 move.w d0,oddeven

 move.w #98,direction
 cmp.w #-2,xSprite
 beq leftscroll
 add.w #4,xSprite

 add.w #6,ySprite
 bsr detect
 sub.w #6,ySprite

 btst #7,d0
 bne unleft

 add.w #14,ySprite
 bsr detect
 sub.w #14,ySprite

 btst #7,d0
 bne unleft

 sub.w #6,xSprite
 bra leftback

unleft:
 sub.w #4,xSprite
 bsr push
 bra leftback

up:
 move.w oddeven,d0
 rol.w #1,d0
 move.w d0,oddeven

 move.w #194,direction
 cmp.w #-2,ySprite
 beq upscroll
	 add.w #4,ySprite
	 add.w #6,xSprite
 bsr detect
	 sub.w #6,xSprite
 btst #7,d0
 bne unup

 add.w #10,xSprite
 bsr detect
 sub.w #10,xSprite

 btst #7,d0
 bne unup

	 sub.w #6,ySprite
 bra upback

unup:

	 sub.w #4,ySprite
 bsr push
 bra upback


down:
 move.w oddeven,d0
 rol.w #1,d0
 move.w d0,oddeven

 move.w #290,direction
 cmp.w #66,ySprite
 beq downscroll
 add.w #16,ySprite
	 add.w #6,xSprite
 bsr detect
	 sub.w #6,xSprite

 btst #7,d0
 bne undown

 add.w #10,xSprite
 bsr detect
 sub.w #10,xSprite

 btst #7,d0
 bne undown

 sub.w #14,ySprite
 bra downback

undown:
 sub.w #16,ySprite	;not ok => 16-16=0
 bsr push
 bra downback

;input: d0.w=mask
;outpt:	d0.b=keys
ReadKBD:
 move.w d0,d1
\loop
 move.w  d1,$600018
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 clr.w d1
 move.b  $60001B,d1
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 move.w	d1,d0
 rts

kbrelease:	;wait for all key to realease
 move.w #0,d0
 bsr ReadKBD
 cmp.b #255,d0
 bne kbrelease
 rts

oldint#1 dc.l 0

sync dc.w 0

newint#1:
 addq.w  #1,sync
 rte

bgproginit:
 move.w counter,d0
 and.w #$7,d0
 cmp.w #0,d0
 bne backrts
 move.w counter,d0
 btst.w #3,d0
 bne \gok
 jmp bgprog1
\gok:
 jmp bgprog2

	include "houses.asm"
	include "walkspri.asm"
	include "walkspri2.asm"
	include "walkspri3.asm"
	include "fire.asm"
;	include "swordspri.asm"
	include "badguys.asm"
	include "othersprites.asm"
invincible:
 dc.w 0

vars:
 ds.b 64

adressa:
 ds.l 8

adressb:
 ds.l 8

new: dc.w $fffb

slot:
;Slot 1
	dc.w 5		;life
	dc.w 5		;lifemax
	dc.w %00000000	;chestvar
	dc.w 0		;xmap
	dc.w 12		;ymap
	dc.w 72		;xSprite
	dc.w 24		;ySprite
	dc.w 64		;xold
	dc.w 48		;yold
	dc.w 290	;direction
	dc.w 0		;money

	dc.w 5		;life
	dc.w 5		;lifemax
	dc.w 0		;chestvar
	dc.w 0		;xmap
	dc.w 12		;ymap
	dc.w 72		;xSprite
	dc.w 24		;ySprite
	dc.w 64		;xold
	dc.w 48		;yold
	dc.w 290	;direction
	dc.w 0		;money

	dc.w 11		;life
	dc.w 11		;lifemax
	dc.w $100	;chestvar
	dc.w 0		;xmap
	dc.w 12		;ymap
	dc.w 72		;xSprite
	dc.w 24		;ySprite
	dc.w 64		;xold
	dc.w 48		;yold
	dc.w 290	;direction
	dc.w 800	;money

	dc.w 7		;life
	dc.w 7		;lifemax
	dc.w 0		;chestvar
	dc.w 0		;xmap
	dc.w 12		;ymap
	dc.w 72		;xSprite
	dc.w 24		;ySprite
	dc.w 64		;xold
	dc.w 48		;yold
	dc.w 290	;direction
	dc.w 0		;money
;Slot erase
	dc.w 5		;life
	dc.w 5		;lifemax
	dc.w 0		;chestvar
	dc.w 0		;xmap
	dc.w 12		;ymap
	dc.w 72		;xSprite
	dc.w 24		;ySprite
	dc.w 64		;xold
	dc.w 48		;yold
	dc.w 290	;direction
	dc.w 0		;money

lifemax:
 dc.w 5


xSprite:
 dc.w 0
ySprite:
 dc.w 0

 ds.b 20
enmybg:
 ds.b 70
curbg: ds.b 62
 ds.b 20

money:	dc.w 0


fileadress:	dc.l	0

emptychest:	dc.b	"This chest is empty",0
yoursword:	dc.b	"Your sword!!",0
optitle:	dc.b	"MENU ",0
opt1:		dc.b	"Resume",0
opt2:		dc.b	"Exit w/o Save",0
opt3:		dc.b	"Exit with Save",0
opt4:		dc.b	"Back to Title",0

optch:		dc.w 1

;TIMING!
counter:	dc.w 0
pushtrig:	dc.w 0
swordpos:	dc.w 0
swordtiming:	dc.w 0
lastkey:	dc.w 0
oddeven:	dc.w 1
holdsword:	dc.w 0
;ENT TIMING!

direction:	dc.w 0
olddir:		dc.w 0
		;    0 	= right
		;   98 	= left
		;  194 	= up
		;  290	= down


str1:	dc.b	"Empty  ",0
str2:	dc.b	"Empty  ",0
str3:	dc.b	"Test   ",0
str4:	dc.b	"Empty  ",0
start:		dc.b	"Zelda 89: Journey to a New World ",0
start2:		dc.b	"            by CCIA",0
start3:		dc.b	"     Version .30b for the Ti-89 ",0
start4: 	dc.b	"cciateam@hotmail.com ",0
start5:		dc.b	"http://ccia.calc.org/ ",0
start6:		dc.b	"Head Programmer:",0
start9:		dc.b	"Jean Milleron",0
start7:		dc.b	"Hard Labor: Eric Meeks",0
start8:		dc.b	"Dead: Garry Hatch",0
fnf:		dc.b	"File not found!",0

filename:	dc.b	"zeldasav",0,0

fileadress2:	dc.l	0
gameoverpic:
	incbin "gameover.huf"
namepicbits:
        incbin "name.huf"
selectpicbits:
        incbin "select.huf"
titlePicBits:
        incbin "zelda.huf"
compressedbg:
	incbin "map.huf"

xold:
 dc.w 0
yold:
 dc.w 0

xmap:
 dc.w 0		;xstart
ymap:
 dc.w 0		;ystart

ymax:
 dc.w 11		;ysize
xmax:
 dc.w 11		;xsize

life:	dc.b 2
chestvar:	dc.w 0

currentslot: dc.l 0

;<bganims
bgprogcur1:	dc.l	0
bgprogcur2:	dc.l	0
;>

falloldx:	dc.w 0
falloldy:	dc.w 0
fallolddir:	dc.w 0
 bss

bgmx:	ds.b 16200
bgprog1:	ds.b 600
bgprog2:	ds.b 600
screensave0	ds.b 2000	;space allocate for Title Screen
screensave1	ds.b 1200
scroll:	ds.b 3226
badgbg: ds.l 384
bg:	ds.l 50
bg2:	ds.l 50
bg3:	ds.l 50
bg4:	ds.l 50
sword1:	ds.l 50
sword2:	ds.l 50
 end